////////////////////////////////////////////////////////////////////////
//
//        File  Name : pipe.h
//        Class Name : pipes
//        Author     : Young-ki Hwang
//        Date       : April 30, 1996
//        Description: This is the "pipes" class definition.
//                     It defines process communication between the
//                     parent and child processes.
//
///////////////////////////////////////////////////////////////////////

#include "ipc.h"
#include "string.h"

#ifndef _pipe_h
#define _pipe_h

class pipes : public ipc
{ 
   private:
        int p[2];                // pipe descriptor: p[o] is for read.
                                 //                  p[1] is for write.
                                                           
	struct                   
	  { char message[128];
            char nickname[15];
	  }data;                 // message to be sent and received between
                                 // parent and child processes.
        strings string1;

    public:
	make_pipe();
        int receive(char* message, char *nickname);
	int receive(int rp,  char* message, char *nickname);
        int send(char *message);
        int send(int wp, char *message);
	int send(char *message, char *nickname);
        int send(int wp, char *message, char *nickname);
	close_writepipe();
        close_readpipe();
        int get_readpipe();
        int get_writepipe();
       
};

#endif




